﻿using Microsoft.Xna.Framework;

namespace XELF.Effects.Noise {

	static class Gradient {
		public static Vector4[] CreateLinearGradient(Vector4[] colors, float[] ratios, int width) {
			var palette = new Vector4[width];
			var index = 0;
			for (int i = 0; i < width; i++) {
				var a = i * (1.0f / 255);
				while (index < ratios.Length - 2 && a >= ratios[index + 1])
					index++;
				var amount = (a - ratios[index]) / (ratios[index + 1] - ratios[index]);
				amount = MathHelper.Clamp(amount, 0, 1);
				Vector4.Lerp(ref colors[index], ref colors[index + 1], amount, out palette[i]);
			}
			return palette;
		}
	}

}
